#ifndef NETWORKSELECTOR_H
#define NETWORKSELECTOR_H

#include "ethernetsettings.h"
#include "networkcreator.h"
#include "networkdeleter.h"

#include <NetworkManagerQt/Connection>
#include <NetworkManagerQt/ConnectionSettings>
#include <NetworkManagerQt/Settings>

#include <QMessageBox>
#include <QMainWindow>
#include <QTreeView>
#include <QPushButton>
#include <QStandardItem>
#include <QStandardItemModel>
#include <QList>
#include <QUuid>
#include <QModelIndex>

QT_BEGIN_NAMESPACE
namespace Ui { class NetworkSelector; }
QT_END_NAMESPACE

class NetworkSelector : public QMainWindow
{
    Q_OBJECT

public:
    NetworkSelector(QWidget *parent = nullptr);
    ~NetworkSelector();

private slots:
    void onTreeSingleClicked(QModelIndex index);
    void onTreeDoubleClicked(QModelIndex index);
    void onCreateClicked();
    void onDeleteClicked();
    void onModifyClicked();

private:
    QStandardItem *connGroupItem(QString itemName);
    void regenConnTree();
    void modifyConnection(QModelIndex index);

    Ui::NetworkSelector *ui;
    QStandardItemModel *connTreeModel;
    QList<QStandardItem *> connTreeList;
    NetworkManager::Connection::List connList;

    QDialog *dialogWindow;
};
#endif // NETWORKSELECTOR_H
